#!/usr/bin/perl
#
# epppt.pl - PowerPoint  HTMLץ
#
    $MAINTAINER  = 'Morikawa Yasuhiro <morikawa@ep.sci.hokudai.ac.jp>';
    $UPDATE      = '2004/03/22';
    $VERSION     = '1.4';
    $URL         =
    'http://www.ep.sci.hokudai.ac.jp/~morikawa/perl/epppt/SIGEN_PUB.htm';
#
#  
#
#    PowerPoint  PNG(ʤɤ) 򸫤䤹
#    饤ɷ, ӥͥ HTML 륹ץ
#
#  ˡ
#
#    ʲΤ褦ʽ񼰤, եȤܤ򵭽Ҥե뤬ɬ
#    (ե̾ menu.txt Ȥ)
#
#    ---------------------------------------------------
#        001:Ϥ
#        002:ܼ
#        003:ط
#             :
#    ---------------------------------------------------
#
#  Х
#
#     ν긫餺
#
#  History
#
#    - 1.4  2004/03/22
#           menu.txt ν񼰤ְäƤ˥顼Ǥ褦˽.
#
#    - 1.3  2004/02/09
#           menu.txt ΥץϤǤ褦ѹ.
#           ץѹ.
#
#    - 1.2  2004/02/09
#           ƽϥե, This page is generated with
#           epppt ... Τ褦ʥåϤ褦ˤ.
#

##################################################
#####                                        #####
##                                     ###
#####                                        #####
##################################################
#
# ܸΤ, jcode Ȥ߹.
require 'jcode.pl'
    || die "jcode.pl is not found.\n".
           "(If your OS is Debian GNU/Linux, you must install \"libjcode-perl\")\n";

# ץΤ, getopts Ȥ߹.
require 'getopts.pl'
    || die "getopts.pl is not found.\n";

# ե̾
$CONFIG_FILE = 'Config.epppt';

##################################################
#####                                        #####
##                                     ###
#####                                        #####
##################################################

# c Τ߰Ȥ.
&Getopts('c:vVxrRmM');

# ̵ϥإɽ
unless ($opt_x || $opt_c || $opt_v || $opt_V ||
	          $opt_r || $opt_R || $opt_m || $opt_M) {
    &Help;
    exit 1;
}
#  v  V ξˤϥСɽ
if ($opt_v || $opt_V) {
    &PrintVersion;
    exit 1;
}
#  r  R ξˤ README.TXT 򥳥ԡΤ
if ($opt_r || $opt_R) {
    &PrintReadme;
    exit 1;
}
#  m  M ξˤ menu.txt Υƥץ졼Ȥ
if ($opt_m || $opt_M) {
    &PrintMenuTxt("menu.txt");
    exit 1;
}
# c ץξ $CONFIG_FILE ѹ
if ($opt_c) {
    $CONFIG_FILE = $opt_c;
}

sub Help() {
    print STDOUT <<EOF;
  epppt.pl:
    USAGE:
      epppt.pl [-vVrRmM] [-x] [-c configfile]

    OPTION:
      -v, -V        : СʥСɽ
      -r, -R        : README.TXT ɽ
      -m, -M        : menu.txt ƥץ졼Ȥ
      -c configfile : եƼ¹
      -x            : ¹ (ե $CONFIG_FILE)

EOF
    &PrintVersion;
}
sub PrintVersion() {
    print STDOUT <<EOF;
  epppt Version $VERSION, Last Update: $UPDATE.
  $MAINTAINER All Right Reserved.

EOF
}

sub PrintMenuTxt() {
    local($menu_txt) = @_;
    print STDOUT "ڡʬ $menu_txt Ϥޤ? [30]: ";
    $pagenum = <STDIN>;
    # 㳰
    $pagenum = "30" unless ($pagenum =~ /^\d+$/);
    # ˥ե뤬, ̥ե
    local($i) = 0;
    while (-f $menu_txt) {
	$i++;
	$menu_txt = "$menu_txt"."."."$i";
    }
    # ե륪ץ & ͤν
    print STDOUT "Creating $menu_txt ...";
    open(MENUTXT, "> $menu_txt")
	|| die "$menu_txt ˽񤭹ळȤޤǤ. /n";
    local($j) = 1;
    for (1..${pagenum}) {
	local($outnum) = sprintf "%03d:\n", $j;
	print MENUTXT "$outnum";
	$j++;
    }
    close(MENUTXT);
    print STDOUT "done\n";
}

##################################################
#####                                        #####
##             եǧ                ###
#####                                        #####
##################################################

unless (-f $CONFIG_FILE) {
    print STDOUT "եǤ $CONFIG_FILE ޤ.\n".
	         "  1. epppt ǥեȤǽ򤹤ʤ \"y\",\n".
		 "  2. Ǥʤ                     \"n\",\n".
		 "  3. $CONFIG_FILE ƥץ졼ȤϤʤ\"m\"\n".
		 "ϤƤ [y/n/M]: ";
    $ans = <STDIN>;

    unless ($ans =~ /^[yY].*$/ || $ans =~ /^[nN].*$/) {
	print STDOUT "Creating $CONFIG_FILE ...";
	&OutputConfig($CONFIG_FILE, $VERSION, $UPDATE, $MAINTAINER);
	print STDOUT "done\n";
	exit 0;
    }
    if ($ans =~ /^[nN].*$/) {
	die "Ǥޤ.\n";
    }
}


##################################################
#####                                        #####
##             ǥե                ###
#####                                        #####
##################################################

##############################
###  
##
# ե
$infofile = "./menu.txt";

# ȥե
$titlefile = "./title.txt";

# ǥåե
$indexfile = "index.html";

# ˥塼ե
$menufile = "menu.html";

# ͥե̾
$thumbnail_file = "thumbnail.html";

#  HTML ե־ǥ쥯ȥ
$htmldir = "html";

# 饤ɲե־ǥ쥯ȥ
$slidedir = "slide";

# ͥե־ǥ쥯ȥ
$thumbdir = "thumbnail";


##############################
###  ʸ
##
# Ϥեܸʸ
# "jis", "euc", "sjis" Τɤ줫
$jpcode = "euc";

##############################
###  
##
## 
# 0: ̵, 1: 뤢
$style_mode = "0";
    # ƥȤο
$style_textcolor       = '#999900';
    # طʿ
$style_bgcolor         = '#FFFFCC';
    # ϤΥ󥯿
$style_linkcolor       = '#666600';
    # ˻ȤΥ󥯿
$style_visitedcolor    = '#666633';
    # ޥ˾褻Υ󥯿
$style_hovercolor      = 'orange';
    # 󥯤... none: ̵, underline: ,
    #             blink: , overline:,
    #             line-through: Ǥä
$style_link_underline  = 'none';
    # 󥯤... normal: , bold: 
$style_link_fontweight = 'bold';

# ΥڡؤΥ󥯤Ѥʸ
$previouslink = '[]';
$nextlink     = '[]';

# ƥڡΥ󥯤ξ岼դ
$upperlink = 'Parent Dirctory';
$upperurl  = '';
$lowerlink = 'ppt ե뢧';
$lowerurl  = '';

# Ϥƥڡղäå
#   - acktext ˤ, åΤΤϤʤ
#   - acklink ꤵƤդĤΥ "::" 
#     Ϥޤ줿ʬ acklink ؤΥ󥯤Ѵ
#   - $VERSION  epppt.pl ΥС󤬽Ϥ
#   - $URL  epppt.pl ֤ URL Ϥ
$acktext = "This page is generated with ::epppt:: Version $VERSION";
$acklink = "$URL";

##############################
###  ͥ
##
# 0: ̵ͥ, 1: ͥ뤢
$thumbnail_mode    = "0";
    # ͥؤΥ󥯤Υå
$thumbnail_link    = "ͥɽ";
    # ͥο
$thumbnail_col_num = "3";


##############################
###  ԡȯ
##
# ǥХåե饰
$debug="0";



##################################################
#####                                        #####
###       桼եɤ߹           ###
#####                                        #####
##################################################

# 桼ե뤬ɤ߹Ϥɤ߹
if (-r $CONFIG_FILE) {
    require "$CONFIG_FILE";
}


##################################################
#####                                        #####
##                㳰                     ###
#####                                        #####
##################################################

# ʸɤ㳰
unless ($jpcode eq 'euc' || $jpcode eq 'sjis' || $jpcode eq 'jis') {
    print STDOUT "Modify \$jpcode from $jpcode to euc" if ($debug);
    $jpcode = 'euc';
}

##################################################
#####                                        #####
##             ץ                  ###
#####                                        #####
##################################################


##################################################
## ȥե뤫饿ȥ
##################################################

$title = &TitleGet($titlefile, $jpcode, $debug);

##################################################
## slide, thumbnail ǥ쥯ȥ
## ե̾͡
##################################################

&ImageRename($slidedir, $debug);
&ImageRename($thumbdir, $debug) if ($thumbnail_mode);


##################################################
## slide, thumbnail ǥ쥯ȥ⤫
## եΥפФ
##################################################

$imgtype = &GetImageType($slidedir, $debug);
$imgtype_thumb = &GetImageType($thumbdir, $debug) if ($thumbnail_mode);


#
# ե뤫, ʥСȥ֥ȤФ.
#
print STDOUT "Get Slide Informations from $infofile ..." unless ($debug);
open(INFOFILE, "$infofile") || die "$infofile ĤޤǤ. \n";
while (<INFOFILE>) {
    # 㳰
    unless ($_ =~ /^(\d){3}:.*$/) {
	die "$infofile γƹԤλϤ 001:.., 002:.. ȤʤäƤɬפޤ.\n"
    }
    chomp;
    # ʸѴ
    &jcode'convert(*_, "$jpcode");
    push(@info, $_);
}
close(INFOFILE);
print STDOUT "done\n" unless ($debug);

#print STDOUT "@info \n";


#
# ʥСȥ֥ȤʬΥƤ.
# (Ǥΰ֤ƱǤ뤿, ξԤ礹뤳Ȥϲǽ)
#
foreach $key (@info){
    @info_parts = split(/:/, $key, 2);
    $info_hash{"$info_parts[0]"} = "$info_parts[1]";
    push(@number, $info_parts[0]);
    push(@subject, $info_parts[1]);
}

#print STDOUT "@number \n";
#print STDOUT "@subject \n";
#print "$info_hash{$number[1]}\n";

#
# ʸɤ jpcode Ѥ meta ˽񤭹ѤѴ.
#
$metajp = &JpcodeToMeta($jpcode, $debug);

#
# Ȥƽ񤭽Фʸ
#
$style_out = &StyleMake($style_mode, $style_textcolor, $style_bgcolor,
			$style_linkcolor, $style_visitedcolor,
			$style_hovercolor, $style_link_underline,
			$style_link_fontweight, $debug);

#
# ǥåκ
#

&MakeIndex($title, $style_out, $metajp, $indexfile, $debug);


#
# ˥塼κ
#    - Хѿ @number  %info_hash 
#      (Ϥä, ϤʤäΤǥܤ)

&MakeMenu($title, $style_out, $jpcode, $metajp,
	  $upperlink, $upperurl, $lowerlink, $lowerurl,
	  $thumnail_mode, $thumbnail_file, $thumbnail_link,
	  $menufile, $debug);

#
#  HTML κ
#    - Хѿ @number  %info_hash 
#      (Ϥä, ϤʤäΤǥܤ)

&MakeHtml($title, $style_out, $previouslink, $nextlink, $imgtype,
	  $acktext, $acklink, $jpcode, $metajp, $debug);

#
# ͥκ
#    - Хѿ @number  %info_hash 
#      (Ϥä, ϤʤäΤǥܤ)

&MakeThumbnail($title, $style_out, $jpcode, $metajp, $htmldir,
	       $thumnail_mode, $thumbnail_file, $thumbdir,
	       $thumbnail_link, $thumbnail_col_num,
	       $imgtype_thumb, $acktext, $acklink, $debug);

#
# λ
#
&EndMessage($debug);


##################################################
#####                                        #####
##             ֥롼                  ###
#####                                        #####
##################################################

sub OutputConfig() {
    local($configfile, $version, $update, $maintainer) = @_;
    open(CONFIGFILE, "> $configfile")
	|| die "$configfile ˽񤭹ळȤޤǤ. /n";
    print CONFIGFILE <<EOF;
#####   $configfile for epppt    #####
##
#  This is Template File for epppt ver $version
#
#  (C) Copyright by $maintainer
#  $update.  All rights reserved.
#
EOF

    print CONFIGFILE <<'EOF';
##############################
###  
##
# ե
$infofile = "./menu.txt";

# ȥե
$titlefile = "./title.txt";

# ǥåե
$indexfile = "index.html";

# ˥塼ե
$menufile = "menu.html";

# ͥե̾
$thumbnail_file = "thumbnail.html";

#  HTML ե־ǥ쥯ȥ
$htmldir = "html";

# 饤ɲե־ǥ쥯ȥ
$slidedir = "slide";

# ͥե־ǥ쥯ȥ
$thumbdir = "thumbnail";


##############################
###  ʸ
##
# Ϥեܸʸ
# "jis", "euc", "sjis" Τɤ줫
$jpcode = "euc";

##############################
###  
##
## 
# 0: ̵, 1: 뤢
$style_mode = "1";
    # ƥȤο
$style_textcolor       = '#999900';
    # طʿ
$style_bgcolor         = '#FFFFCC';
    # ϤΥ󥯿
$style_linkcolor       = '#666600';
    # ˻ȤΥ󥯿
$style_visitedcolor    = '#666633';
    # ޥ˾褻Υ󥯿
$style_hovercolor      = 'orange';
    # 󥯤... none: ̵, underline: ,
    #             blink: , overline:,
    #             line-through: Ǥä
$style_link_underline  = 'none';
    # 󥯤... normal: , bold: 
$style_link_fontweight = 'bold';

# ΥڡؤΥ󥯤Ѥʸ
$previouslink = '[]';
$nextlink     = '[]';

# ƥڡΥ󥯤ξ岼դ
$upperlink = 'Parent Dirctory';
$upperurl  = '';
$lowerlink = 'ppt ե뢧';
$lowerurl  = '';

# Ϥƥڡղäå
#   - acktext ˤ, åΤΤϤʤ
#   - acklink ꤵƤդĤΥ "::" 
#     Ϥޤ줿ʬ acklink ؤΥ󥯤Ѵ
#   - $VERSION  epppt.pl ΥС󤬽Ϥ
#   - $URL  epppt.pl ֤ URL Ϥ
$acktext = "This page is generated with ::epppt:: Version $VERSION";
$acklink = "$URL";


##############################
###  ͥ
##
# 0: ̵ͥ, 1: ͥ뤢
$thumbnail_mode    = "1";
    # ͥؤΥ󥯤Υå
$thumbnail_link    = "ͥɽ";
    # ͥο
$thumbnail_col_num = "3";


##############################
###  ԡȯ
##
# ǥХåե饰
$debug="0";



EOF

    print CONFIGFILE <<EOF;
######################################################################
# ƤӽФߤ require '${configfile}'  1 ֤褦ˤ.
# ǤʤХե뤬ĤäƤʤȤȽꤵ.
1;
EOF

    close(CONFIGFILE);
}


# ȥե뤫饿ȥФ
#
# 
#	$titlefile	ȥ뤬񤭹ޤƤե
#
# ֵ
#	եΰܤ, Ԥ֤
#
sub TitleGet() {
    local($titlefile, $jpcode, $debug) = @_;
    local($title);
    print STDOUT "Get Title form $titlefile ...";
    open(TITLEFILE, "$titlefile")
	|| die "$titlefile ĤޤǤ. \n".
	    "$titlefile 1Ԥǥȥ񤭹ǲ. \n";
    while (<TITLEFILE>) {
	chomp;
	# ʸѴ
	&jcode'convert(*_, "$jpcode");
	push(@title_lists, $_);
    }
    # ܤФ.
    $title = $title_lists[0];
    close(TITLEFILE);
    # ǥХåå
    print STDOUT "TitleGet: \$title = $title\n" if ($debug);
    # ֵͤ
    print STDOUT "done.\n";
    return $title;
}

#
# ǥ쥯ȥ1ܤΥեβפФ
#
# 
#	$dir		ǥ쥯ȥ
#
# ֵ
#	ǥ쥯ȥ1ܤΥեγĥҤ֤

sub GetImageType() {
    local($dir, $debug) = @_;
    print STDOUT "Get ImageType from $dir ..." unless ($debug);
    # ǥ쥯ȥꥪץ
    opendir(DIR, "${dir}")
	|| die "${dir} ǥ쥯ȥ꤬¸ߤޤ. \n";
    local(@imgfiles) = grep(!/^\.\.?$/, readdir(DIR));
    closedir(DIR);
    # ǥ쥯ȥ˲뤫å
    unless ($imgfiles[0]) {
	die "$dir ǥ쥯ȥ˥ե뤬¸ߤޤ. \n";
    }
    # ܤΥե򸫤. (ݤ)
    local($sampleimg) = $imgfiles[0];
    local(@imgname_parts) = split(/\./, $sampleimg);
    local($imgtype) = $imgname_parts[$#imgname_parts];

    # ǥХåѽ
    print STDOUT "GetImageType: In $dir, ImageType is $imgtype.\n" if ($debug);
    print STDOUT "done.\n" unless ($debug);

    return $imgtype;
}

#
# ʸɤ jpcode Ѥ meta ˽񤭹ѤѴ륵֥롼
#
sub JpcodeToMeta($jpcode, $debug) {
    print STDOUT "Recognize Japanese Code is $jpcode ..." unless ($debug);
    local($jpcode, $debug) = @_;
    local($metajp, %meta_jpcode_list);
    %meta_jpcode_list = (
			 'euc',		'euc-jp',
			 'sjis',	'Shift_JIS',
			 'jis',		'iso-2022-jp',
			);
    $metajp = $meta_jpcode_list{"$jpcode"};
    # ǥХåѽ
    print STDOUT "JpcodeToMeta: \$jpcode = $jpcode => \$metajp = $metajp\n" if ($debug);
    print STDOUT "done.\n" unless ($debug);
    return $metajp;
}

#
# ֥롼
#
# 
#	$mode		0: ̵, 1: 뤢
#	$textcolor	ƥȤο
#	$bgcolor	طʿ
#	$linkcolor	ϤΥ󥯿
#	$visitedcolor	˻ȤΥ󥯿
#	$hovercolor	ޥ˾褻Υ󥯿
#	$link_underline	󥯤... none: ̵, underline: ,
#				    blink: , overline:,
#				    line-through: Ǥä
#	$link_fontweight 󥯤... normal: , bold: 
#
#
# ֵ
#	Ȥƽ񤭽Фϥå
#
sub StyleMake() {
    local($mode, $textcolor, $bgcolor, $linkcolor, $visitedcolor,
	  $hovercolor, $link_underline, $link_fontweight, $debug) = @_;
    local($style_output);
    # Ѥ˽񤭽Фʸ.
    $style_output =
	'  <style type="text/css">'. "\n".
	'    <!--'. "\n".
        "      body{\n".
        "           color:$textcolor;\n".
        "           background-color:$bgcolor;\n".
        "          }\n".
        "      a:link{color:$linkcolor;}\n".
        "      a:visited{color:$visitedcolor;}\n".
        "      a:hover{color:$hovercolor;}\n".
        "      a{\n".
        "        text-decoration:$link_underline;\n".
        "        font-weight:$link_fontweight;\n".
        "      }\n".
        "    -->\n".
        "  </style>\n";

    # ꤷʤ, nul ʸ֤
    undef $style_output unless ($mode);

    # ǥХåѽ
    print STDOUT "StyleMake: \$style_output = \n $style_output\n" if ($debug);
    return $style_output;
}


#
# ƥǥåե֥롼
#
sub MakeIndex {
    local($title, $style_out, $metajp, $indexfile, $debug) = @_;
    print STDOUT "Creating Index File ..." unless ($debug);
    open(INDEXFILE, "> $indexfile")
	|| die "$indexfile ˽񤭹ळȤޤǤ. /n";
    #
    # إåν񤭽Ф
    #
    print INDEXFILE <<EOF;
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=${metajp}">
  <title>$title</title>
$style_out
</head>

<frameset cols="20%,80%">
<frame src="./${menufile}" name="menu" scrolling="yes">
<frame src="./${htmldir}/001.html" name="display" scrolling="yes">
</frameset>

</html>
EOF
    print STDOUT "done.\n" unless ($debug);
    close(INDEXFILE);
}


#
# ˥塼եκ֥롼
#    - Хѿ @number  %info_hash 
#      (Ϥä, ϤʤäΤǥܤ)
#
sub MakeMenu() {
    local($title, $style_out, $jpcode, $metajp,
	  $upperlink, $upperurl, $lowerlink, $lowerurl,
	  $thumnail_mode, $thumbnail_file, $thumbnail_link,
	  $menufile, $debug) = @_;
    print STDOUT "Creating Menu File ..." unless ($debug);
    # ʸѴ
    &jcode'convert(*upperlink, "$jpcode");
    &jcode'convert(*upperurl, "$jpcode");
    &jcode'convert(*lowerlink, "$jpcode");
    &jcode'convert(*lowerurl, "$jpcode");
    &jcode'convert(*thumbnail_link, "$jpcode");
    open(MENUFILE, "> $menufile")
	|| die "$menufile ˽񤭹ळȤޤǤ. /n";
    #
    # إåν񤭽Ф
    #
    print MENUFILE <<EOF;
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=${metajp}">
  <title> $title Menu</title>
$style_out
</head>
<body>

EOF
    #
    # դ
    #
    if ($upperlink && $upperurl) {
	print MENUFILE <<EOF;
<small>
  <a href="${upperurl}" target="_top">${upperlink}</a>
</small>
<hr noshade size="1">

EOF
    }
    #
    # ͥ⡼ɤؤΥ
    #
    if ($thumbnail_mode && $thumbnail_file && $thumbnail_link) {
	print MENUFILE <<EOF;
<center><small>
  <a href="${thumbnail_file}" target="display">${thumbnail_link}</a>
</small></center>
<hr noshade size="1">

EOF
    }
    #
    # ܼ󥯤Υإåʬ񤭽Ф
    #
    print MENUFILE <<EOF;
<ol><small>
EOF
    foreach $num (@number){
	print MENUFILE <<EOF;
<li><a href="./${htmldir}/${num}.html" target="display">$info_hash{$num}</a><br>

EOF
    }
    #
    # ܼʬΥեåν񤭽Ф
    #
    print MENUFILE <<EOF;
</small></ol>

EOF
    #
    # դ
    #
    if ($lowerlink && $lowerurl) {
	print MENUFILE <<EOF;
<hr noshade size="1">
<small><div align="right">
  <a href="${lowerurl}" target="_top">${lowerlink}</a>
</div></small>

EOF
    }
    #
    # եåν񤭽Ф
    #
    print MENUFILE <<EOF;
</body>
</html>
EOF
    close(MENUFILE);
    # ǥХåѽ
    if ($debug) {
	print STDOUT "MakeMenu:\n" ;
	foreach $num (@number){
	    print STDOUT "           ${num} : $info_hash{$num}\n";
	}
    }
    print STDOUT "done.\n" unless ($debug);
}


#
#  HTML ե֥롼
#    - Хѿ @number  %info_hash 
#      (Ϥä, ϤʤäΤǥܤ)
#
sub MakeHtml {
    local($title, $style_out, $previouslink, $nextlink, $imgtype,
	  $acktext, $acklink, $jpcode, $metajp, $debug) = @_;
    # ǥХåѥåإå
    print STDOUT "MakeHtml:\n" if ($debug);

    # ʸѴ
    &jcode'convert(*previouslink, "$jpcode");
    &jcode'convert(*nextlink, "$jpcode");
    #
    # ǥ쥯ȥκȺ
    #
    print STDOUT "Removing Old HTML Files ..." unless ($debug);
    print STDOUT "  Remove ./${htmldir}, and Mkdir ${htmldir}" if ($debug);

    system("/bin/rm -rf ./${htmldir}/") if -d "./${htmldir}";
    mkdir("${htmldir}", 0755);

    print STDOUT "done.\n". "Creating HTML Files ..." unless ($debug);

    # ߤΥǥ쥯ȥξ
    local($current_dir) = `pwd`;
    chomp $current_dir;
    # ǥ쥯ȥư
    chdir("./${htmldir}");
    print STDOUT "  Move to $htmldir ...\n" if ($debug);

    # ֹȤ $element_num Ѱ
    local($element_num) = 0;


    while ($number[$element_num]) {
	local($allpage_num) = $#number + 1;
	local($previous_num) = $element_num - 1;
	local($next_num) = $element_num + 1;
	local($htmlnumber) = $number[$element_num];
	local($htmlfile) = "${htmlnumber}.html";
	#
	# إåκ
	#
	open(HTMLFILE, "> $htmlfile")
	    || die "$htmlfile ˽񤭹ळȤޤǤ. /n";
	print HTMLFILE <<EOF;
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=${metajp}">
  <title>$title [$info_hash{$htmlnumber}]</title>
$style_out
</head>
<body>
EOF
	#
	# ΥڡؤΥ, ڡ/ڡ, ν񤭽Ф
	#
	print HTMLFILE <<EOF;

<hr noshade size="1">
<table width="90%">
  <tr>
    <td width="30%">
EOF
	# ǽΥڡȺǸڡξϥ󥯤ŽʤΤ
	# ʬ.

	# ǽΥڡ [] ˥󥯤Žʤ
	if ($previous_num < 0) {
	    print HTMLFILE <<EOF;
      ${previouslink}
      <A HREF="./$number["$next_num"].html">${nextlink}</A>
EOF
	}
	# ǸΥڡ [] ˥󥯤Žʤ
	elsif ($next_num > $#number) {
	    print HTMLFILE <<EOF;
      <A HREF="./$number["$previous_num"].html">${previouslink}</A>
      ${nextlink}
EOF
	}
	# ¾Ǥξ˥
	else {
	    print HTMLFILE <<EOF;
      <A HREF="./$number["$previous_num"].html">${previouslink}</A>
      <A HREF="./$number["$next_num"].html">${nextlink}</A>
EOF
	}


	print HTMLFILE <<EOF;
    </td>
    <td width="30%" align="center">
    $next_num / $allpage_num
    </td>
    <td align="right">
      $info_hash{$htmlnumber}
    </td>
  </tr>
</table>
<hr noshade size="1">

EOF
	#
	# ŽĤʬ
	#
	print HTMLFILE <<EOF;
<img src="../${slidedir}/${htmlnumber}.${imgtype}" alt="$info_hash{$htmlnumber}">

EOF
	#
	# ڡΥå
	#
	if ($acktext) {
	    print HTMLFILE <<EOF;
<hr noshade size="1">
<div align="right">
EOF
	    local($_) = $acktext;
	    if ($acklink_out = $acklink) {
		${acklink_out} = "<b><a href=\"${acklink_out}\" target=\"_top\">";
		s/::/${acklink_out}/ || s/^/${acklink_out}/;
		${acklink_out} = "</a></b>";
		s/::/${acklink_out}/ || s/$/${acklink_out}/;
	    }
	    print HTMLFILE "$_\n";
	    print HTMLFILE ": at ", &FmtTime, "</div>\n";
	}
	#
	# եåκ
	#
	print HTMLFILE <<EOF;
</body>
</html>
EOF
	close(HTMLFILE);
	print STDOUT "${element_num}, " unless ($debug);
	# ǥХåѽ
	if ($debug) {
	    print STDOUT "  page: ${element_num}\n".
		         "    allpage : ${allpage_num}\n".
		         "    previous: ${previous_num}\n".
		         "    next    : ${next_num}\n".
		         "    html_num: ${htmlnumber}\n".
		         "    htmlfile: ${htmlfile}\n";
	}
	# Υ롼פ
	$element_num++;
    }
    # Υǥ쥯ȥ
    chdir("$current_dir");
    print STDOUT "  Back to $current_dir.\n" if ($debug);
    print STDOUT "done.\n" unless ($debug);
    return;
}

#
# ֽѥ֥롼
#
sub FmtTime {
	local($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)
	 = localtime time;
	sprintf "%4d/%02d/%02d %02d:%02d:%02d",
		$year + 1900, $mon + 1, $mday, $hour, $min, $sec;
}

#
# ֥ͥ롼
#    - Хѿ @number  %info_hash 
#      (Ϥä, ϤʤäΤǥܤ)
#
sub MakeThumbnail() {
    local($title, $style_out, $jpcode, $metajp, $htmldir,
	  $thumnail_mode, $thumbnail_file, $thumbdir,
	  $thumbnail_link, $thumbnail_col_num,
	  $imgtype_thumb, $acktext, $acklink, $debug) = @_;
    # ǥեȤο
    local($thumbnail_col_num_def) = "3";

    # ǥХåѥå
    print STDOUT "MakeThumbnail: \$thumbnail_mode = $thumbnail_mode\n" if ($debug);
    # $thumnail_mode  (0) ʤв⤻˽λ
    return unless ($thumbnail_mode);

    # 桼, ǥХåѥå
    print STDOUT "Creating Thumbnail File ..." unless ($debug);
    if ($debug) {
	print STDOUT "  \$thumbnail_file = $thumbnail_file\n".
	             "  \$thumbdir = $thumbdir\n".
	             "  \$thumbnail_link = $thumbnail_link\n".
	             "  \$thumbnail_col_num = $thumbnail_col_num\n".
	             "  \$thumbdir = $thumbdir\n";
    }
    # ʸѴ
    &jcode'convert(*thumnail_link, "$jpcode");
    # 㳰
    unless ($thumbnail_col_num =~ /^\d+$/){
	print STDOUT "  Modify \$thumbnail_col_num ".
	    "from $thumbnail_col_num to $thumbnail_col_num_def.\n" if ($debug);
	$thumbnail_col_num = $thumbnail_col_num_def;
    }
    # ե륪ץ
    open(THUMBFILE, "> $thumbnail_file")
	|| die "$thumbnail_file ˽񤭹ळȤޤǤ. /n";
    #
    # إåν񤭽Ф
    #
    print THUMBFILE <<EOF;
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=${metajp}">
  <title> $title Thumbnail</title>
$style_out
</head>
<body>

EOF
    #
    # ơ֥Υإåʬ񤭽Ф
    #
    print THUMBFILE <<EOF;
<table border="0" cellspacing="20" cellpadding="0" align="center">
EOF

    #
    # ͥʬ
    #

    # ֹȤ $element_num Ѱ
    local($element_num) = 0;

    while ($number[$element_num]) {
	local($thumbnum) = $number[$element_num];
	local($amari) = $thumbnum % $thumbnail_col_num;

	#
	# ơ֥֤ˤä <tr> ΤĤ򤪤ʤ.
	# ü : 3n+1 ($amari == 1)
	# ü : 3n   ($amari == 0)
	if ($amari == 1) {
	    print THUMBFILE <<EOF;
  <tr align="center" valign="bottom">
EOF
	}

        print THUMBFILE <<EOF;
    <td align="center" valign="top">
      <a href="./${htmldir}/${thumbnum}.html">
        <img src="./${thumbdir}/${thumbnum}.${imgtype_thumb}" border="0" alt="$info_hash{$thumbnum}">
      </a>
      <br>
      <small>
         $info_hash{$thumbnum}
      </small>
    </td>
EOF
	if ($amari == 0) {
	    print THUMBFILE <<EOF;
  </tr>
EOF
	}
	# ǥХåѽ
	if ($debug) {
	    print STDOUT "    ${thumbdir}/${thumbnum}.${imgtype_thumb} -> ".
		           "./${htmldir}/${thumbnum}.html\n";
	}
	$element_num++;
    }

    #
    # ơ֥Ƿ礱Ƥʬɲ
    #
    local($total) = $#number + 1 ; # ο
    local($total_amari) = $total % $thumbnail_col_num;
    local($total_nokori) = $thumbnail_col_num - $total_amari;
    local($i);
    # ǥХåѽ
    if ($debug) {
	print STDOUT "  \$total        = $total\n".
	             "  \$total_amari  = $total_amari\n".
	             "  \$total_nokori = $total_nokori\n";
    }
    
    for ($i = $total_nokori; $i > 0; $i--) {
	print THUMBFILE <<EOF;
    <td>&nbsp;</td>
EOF
    }
    if ($total_nokori) {
	print THUMBFILE <<EOF;
  </tr>
EOF
    }

    #
    # ơ֥Υեåʬ񤭽Ф
    #
    print THUMBFILE <<EOF;
</table>
EOF

    #
    # ڡΥå
    #
    if ($acktext) {
	print THUMBFILE <<EOF;
<hr noshade size="1">
<div align="right">
EOF
	local($_) = $acktext;
	if ($acklink_out = $acklink) {
	    ${acklink_out} = "<b><a href=\"${acklink_out}\" target=\"_top\">";
	    s/::/${acklink_out}/ || s/^/${acklink_out}/;
	    ${acklink_out} = "</a></b>";
	    s/::/${acklink_out}/ || s/$/${acklink_out}/;
	}
	print THUMBFILE "$_\n";
	print THUMBFILE ": at ", &FmtTime, "</div>\n";
    }

    #
    # եåν񤭽Ф
    #
    print THUMBFILE <<EOF;
</body>
</html>
EOF
    close(THUMBFILE);
    
    print STDOUT "done.\n" unless ($debug);
}



# λåɽ (ǥХå⡼ɻ)
#
sub EndMessage() {
    local($debug) = @_;
    print STDOUT "EndMessage: Execute Successfully!!\n" if ($debug);
    print STDOUT "Complete.\n" unless ($debug);
}




##################################################
#####                                        #####
##       ե̾Ѵ֥롼        ###
#####       (絬ϤʤΤ, ʬΥ)             #####
##################################################

# ե͡ॵ֥롼
#
# 
#	$dir		ưǥ쥯ȥ
#	$debug		ǥХåѥե饰
#
# ֵ
#	ʤ
#
#  
#
#    1.PNG, 2.PNG  231.PNG Ȥäե
#    001.png, 002.png  231.png Ȥ˥͡ह륹ץ
#
#
sub ImageRename() {
    local($dir, $debug) = @_;
    print STDOUT "Rename image files in $dir ...";
    
    ########################################################
    ##  ǥե
    ########################################################
    
    # 
    local($len) = 3;
    
    # եη
    local(@treat) = ('gif', 'GIF', 'jpg', 'JPG', 'jpeg', 'JPEG',
		     'png', 'PNG', 'bmp', 'BMP', 'tif', 'TIF',
		     'tiff', 'TIFF');
    
    ########################################################

    # ߤΥǥ쥯ȥξ
    local($current_dir) = `pwd`;
    chomp $current_dir;
    # ǥ쥯ȥư
    chdir($dir);
    print STDOUT "  Move to $dir ...\n" if ($debug);
    
    
    # ȥǥ쥯ȥ".", ".."ƤΥե
    opendir(DIR, ".");
    local(@allfiles) = grep(!/^\.\.?$/, readdir(DIR));
    closedir(DIR);
    
    ########################################################
    ##   եǤʤä,
    ##   Υե̾ǤʤΤ
    ########################################################
    
    foreach $file (@allfiles){
	local(@file_parts) = split(/\./, $file);
	#print STDOUT "file name is $file_parts[0], expand is $file_parts[$#file_parts] \n";
	#
	#  a.gif  ab0.png Ȥäե̾ޤޤƤ
	#  顼֤
	#
	unless ($file_parts[0] =~ /^\d+$/){
	    die "Υǥ쥯ȥˤ 123.gif Τ褦̾Ǥʤե뤬ޤޤƤ, ¹ԤǤޤǤ. \n";
	}
	#
	#  @treat ˴ޤޤƤʤĥҤξϥ顼֤.
	#
	local($img_ok, $imgtype);
	undef $img_ok;
	foreach $imgtype (@treat){
	    if ($file_parts[$#file_parts] eq $imgtype){
		$img_ok = 1;
	    }
	}
	unless ($img_ok){
	    die "Υǥ쥯ȥˤ, ΥץȤǤϥݡȤƤʤΥե뤬¸ߤ뤿, ¹ԤǤޤǤ. \n";
	}
    }
    
    ######################################################
    ##  ե̾͡
    ######################################################

    local($file);
    foreach $file (@allfiles){
	local(@file_parts) = split(/\./, $file);
	local($filename) = $file_parts[0];
	local($imgtype) = $file_parts[$#file_parts];
	#
	# եΥʥСηˤ
	#
	if ($len < length($filename)){
	    # 顼ޡ
	    local($error) = 1;
	    local($whole_error) = 1;
	    warn "͡हե̾ĹΥե̾ĹûꤵƤ뤿, ˽ޤǤ. \n";
	} else {
	    # 顼ޡβ
	    $error = 0;
	}
	local($new_filename) = sprintf('%.' . $len . 'd', $filename);
	
	#print STDOUT $new_filename;
	
	#
	# ĥҤʸˤ
	#
	local($new_imgtype) = $imgtype;
	$new_imgtype =~ tr/A-Z/a-z/;
	
	#print STDOUT $new_imgtype;
	
	rename("$file", "$new_filename\.$new_imgtype");

	if ($debug) {
	    print STDOUT "    $file -> $new_filename\.$new_imgtype";
	    print STDOUT "\t \[Irregular Rename...\]" if $error == 1 ;
	    print STDOUT "\n";
	}
    }

    if ($debug) {
	if ($whole_error == 1){
	    print STDOUT "    Ĥΰ۾ʽԤ줿ǽޤ. \n";
	} else {
	    print STDOUT "    ˽λޤ. \n";
	}
    }
    
    # Υǥ쥯ȥ
    chdir("$current_dir");
    print STDOUT "  Back to $current_dir.\n" if ($debug);
    print STDOUT "done.\n";
    return;
}


##################################################
#####                                        #####
##         README.TXT ϥ֥롼         ###
#####      (Ƥ README.TXT Υԡ)      #####
##################################################


sub PrintReadme() {
    print STDOUT <<'EOF';
 epppt (EPnetFaN PowerPoint ) åȡ

   PowerPoint ե򸫤䤹 HTML Ѵ Perl ץ

 

   PowerPoint ϥץ쥼ơ, ͤ˸褦
   HTML ѴΤݤ.
   (PowerPoint ǡHTML¸פȤ, Windows Ǥʤ
    ˤʤä¸)

   ΥץȤΥåȤȤȤ, ɤΥץåȥեǤ
   뤳ȤǤ, 䤹(?)HTMLե뤳Ȥ.


 ʪ

   epppt.tar.gz եŸ뤳ȤǰʲΥե뤬Ǥ
   ϤǤ.

      epppt.pl          HTML եޥåȤPerlץ
      sample            ץ
      README.TXT        Υե

   (ȯѥġ)
      Config_epppt_dev  ȯ epppt ե
      Makefile          make ѤΥե


 ץ (ޤ)

   sample ǥ쥯ȥˤ, epppt Υץ뤬֤Ƥ.
   (ΥץȤ뤫ɤ, ƥ epppt 
    Ȥ뤫ɤΥƥȤˤʤ)

    title.txt	     ץΥȥե
    menu.txt	     ץΥ˥塼ե
    slide	     ץΥ饤ɲ֤
    thumbnail	     ץΥ֤ͥ
    Makefile	     make ѥե
    ORG	     ѥե/ǥ쥯ȥ֤
    Config.epppt   epppt Υץե
    epppt.ppt	     ץ ppt ե

    HTML 

      sample ˰ư, epppt ޥɤ¹Ԥ

        $ cd sample
	$ perl ../epppt.pl -x

      , sample ǥ쥯ȥʲ, index.html ,
      줿 HTML ǤϤǤ.

      ֥饦Ǽºݤ˸Ƥߤߤ

      
    

       HTML õ, ,

        $ make clean

      Ȥɤ.


 HTML 

    Windows ǹԤ

      ޤ, Windows ¦ ppt ե뤫եɬפ.

      1. soi ġ P2Hפ

	 ppt ե뤫եΤˤ soi ġΰ
	 Ǥ P2HפǤ.
	 ʲ URL 󥯤é, p2h.exe .

	   http://www.soi.wide.ad.jp/doc/mate/detail.html

             ޤ

	   http://www.soi.wide.ad.jp/soibeans/

	 ʤߤ, p2h.exe μΤϰʲ URL ˤ.
	 (嵭Υڡ󥯤ŽƤ)

	   http://www.soi.wide.ad.jp/pub/software/P2H/

	     ޤ

	   http://www.soi.wide.ad.jp/soibeans/P2H/


      2. 饤ɲѥǥ쥯ȥκ

	 饤ɲݴɤǥ쥯ȥslideפ.
	 ˤϲեʳΤΤ֤ʤ


      3. P2H ǥ饤Ѳե

	 a. P2H ư
	 b. FileעOpen PPT FileפŪ ppt ե򳫤
         c. FileעSave Locationפ slide ǥ쥯ȥ
	 d. Imageפ˥åĤ, PNGפȤ
	 e. Widthפ 640, Heightפ 480 ˤ
	       1024x768 ˥оݤˤϤΥŬ,
		 ¾ΥˤƤ epppt ϽǤ.
	 f. Exportץܥ򲡤Ʋ
	 g. slide ǥ쥯ȥʲ 1.PNG  **.PNG Ƥ뤳Ȥǧ


      3. ͥѥǥ쥯ȥκ
	  ͥʤɬפʤ.

	 ͥݴɤǥ쥯ȥthumbnailפ.
	 ˤϲեʳΤΤ֤ʤ


      4. P2H ǥͥѲե
	  ͥʤɬפʤ.

	 a. P2H ư
	 b. FileעOpen PPT FileפŪ ppt ե򳫤
         c. FileעSave Locationפ
	    thumbnail ǥ쥯ȥ
	 d. Imageפ˥åĤ, PNGפȤ
	 e. Widthפ 200, Heightפ 150 ˤ
	       1024x768 ˥оݤˤϤΥŬ,
		 ¾ΥˤƤ epppt ϽǤ.
	 f. Exportץܥ򲡤Ʋ
	 g. thumbnail ǥ쥯ȥʲ 1.PNG  **.PNG
	    Ƥ뤳Ȥǧ


       ppt եΥȥե.

      5. ppt եΥȥtitle.txtפ˽񤭹.
           Ȥ 1Ԥǽ񤭹ळ
	     sample  title.txt 򻲾Ȥߤ
         

       ppt եξ.

      6. ppt եȤ򸫤ʤ, Υƥȥե
         menu.txtפ

	 񼰤

		001:<1ĤΥ饤ɤ>
		002:<2ĤΥ饤ɤ>
		003:<3ĤΥ饤ɤ>
			    :

	 Ȥʤ. Ūˤ

		001:Ϥ
		002:ܼ
		003:BIOSä?
		     :

	 Ƚ񤭽Фɤ.

	  sample  menu.txt 򻲾Ȥߤ.

      Ǹ, ޤǤǺ slide, thumbnail, title.txt, menu.txt 
      Linux ĶΥޥ (Web ФǤǤ礦) ˥ԡ.


    Linux (Web )ǹԤ

      0. epppt.pl ѤǤ뤿ˤ...

	 a. perl Ȥ
	    - 칶 Web ФʤɬȤ
	    - perl 5.6.1 ưǧ

	    -  ѥ˴ؤ 
		 epppt.pl  Debian δĶǺΤ
		 perl Υѥ /usr/bin/perl ȤʤäƤ.
		 ¾ OS ξϥѥۤʤ礬Τ
		 ѹ뤳
		 (perl Υѥ which perl ȤΤ뤳ȤǤ)

		 ѹ, epppt.pl Τΰ־ιԤ
		 #!/usr/bin/perlפ񤭴Ф褤

	 b. jcode.pl Ȥ (ܸʸѥ饤֥Ǥ)
	    - 칶 Web ФʤɬȤ
	    - Debian GNU/Linux 3.0 ʤ, libjcode-perl ѥå
	      󥹥ȡ뤹뤳Ȥ, ƥȤ߹
	    - jcode.pl ܲȤǤ http://srekcah.org/jcode/ 
	      ɤ, jcode.pl ˥ե̾Ѵ,
	      ץ¹ԤݤΥȥǥ쥯ȥ,
	      /usr/lib/perl5 ֤ɤ

         ʤ, ưǧΤ sample ǥ쥯ȥ꤬ѰդƤ.
	 ⤷ⲼμˤäƤޤԤʤ,
	 sample ʲưåԤʤäߤ.


      1. slide, thumbnail, title.txt, menu.txt ֤˰ư

	 title.txt  menu.txt ǥ쥯ȥˤ줫 epppt.pl 
	  index.html ֤.


      2. ե Config.epppt 

	 title.txt, menu.txt ǥ쥯ȥޤǰư,
	 ʲΤ褦 epppt.pl ޥɤѤ.

	    $ <epppt.pl֤Ƥǥ쥯ȥ>/epppt.pl -x

	 ,

	    եǤ Config.epppt ޤ.
	      1. epppt ǥեȤǽ򤹤ʤ "y",
	      2. Ǥʤ                     "n",
	      3. Config.epppt ƥץ졼ȤϤʤ"m"
	    ϤƤ [y/n/M]:

	 ɽΤ, "m" 򲡤 Enter 򲡤.

	 , Config.epppt Υƥץ졼Ȥ.

	   dcppt ѼԤγͤ

	    , "y" 򲡤ƥǥեȤǽ򤹤
	    ϰ dcppt ưȰˤʤ.
	    Config.epppt ʤɤ꤬ݤʾϤ
	    ߤ.

	     + ǥեȽħ
	       - ̵ͥ
	       - ˥塼ξ岼Υ̵
	       - 륷Ȥˤʸ̵
	       - ʸ euc


      3. Config.epppt 

	 Config.epppt  emacs  jvim ʤɤܸɽǽ
	 ǥǳ, Խ.

	  

	    Ƽեǥ쥯ȥ꤬ǽǤ뤬,
	    Ūѹɬפ̵.
	    ѹκݤˤ, 嵭ѰդƤե
	    ǥ쥯ȥ̾򤽤碌ѹɬפ
	    Τ.

	  ʸ

	      # Ϥեܸʸ
	      # "jis", "euc", "sjis" Τɤ줫
	      $jpcode = "euc";

	    ǥեȤ euc , Windows Ķοͤʤɤ
	    sjis ǤɤΤΤʤ.
	    (嵭˳ΰʳϤ
	     euc ˤʤΤ.)


	  

	      # 0: ̵, 1: 뤢
	      $style_mode = "1";
	          # ƥȤο
	      $style_textcolor       = '#999900';
		          :

	    ʸοطʿ꤬ǽǤ.
	    ѿꤷߤ.
	    ꤬ݤʾ $style_mode  0 ˤ뤳Ȥ,
	    ̵ˤǤ.

	      
	      # ΥڡؤΥ󥯤Ѥʸ
	      $previouslink = '[]';
	      $nextlink     = '[]';

	    饤ɤΥڡֺݤΥ󥯤Υå
	    Ǥ.

	      $upperlink = 'Parent Dirctory';
	      $upperurl  = '';
	      $lowerlink = 'ppt ե뢧';
	      $lowerurl  = '';

	    ˽Ф˥塼ξ岼˥󥯤դ뤳ȤǤ.
	    $upperlink, $lowerlink ʸλ,
	    $upperurl, $lowerurl  URL λԤʤ.
	     $upperlink  $lowerlink ʤΤ,
	    ѹƤ⹽ʤ.
	    Ĥ, 줾, ɤ餫ǤˤʤäƤ
	    󥯤ΤΤǤʤΤ.


	  ͥ

	      # 0: ̵ͥ, 1: ͥ뤢
	      $thumbnail_mode    = "1";
	          # ͥؤΥ󥯤Υå
	      $thumbnail_link    = "ͥɽ";
		  # ͥο
	      $thumbnail_col_num = "3";

	    ͥԤʤ.



      3. epppt Ѥ HTML ե

	 , title.txt, menu.txt ǥ쥯ȥޤǰư,
	 ʲΤ褦 epppt.pl ޥɤѤ.

	    $ <epppt.pl֤Ƥǥ쥯ȥ>/epppt.pl -x

	 , ʲΥե뷲ϤǤ.

	   index.html     ǥåե
                              (frame  menu.html  ***.html ƤӽФ)
	   menu.html      ˥塼ե
	   thumbnail.html ͥե ()
	   html           frame α¦˽Ф HTML Ǽǥ쥯ȥ
	   html/***.html
			 001.html, 002.html Ȥä HTML ե,
			   줾줬, pic/001.png, pic/002.png 
			   ƤӽФƤ.
	   slide/***.gif [png, ...],
	     thumbnail/***.gif [png, ...]
			 , soi ġǤѴʤ
			   1.GIF, 2.GIF ʤɤȤʤäƤϤ,
			   001.gif, 002.gif Ȥä褦˥ե̾
			   ѹƤϤǤ.

   ʾɬפ HTML ե뤬줿ϤǤ.

EOF
}
